#include <stdio.h>

int main() {
    int N, Q,a=0;
    scanf("%d %d", &N, &Q);

    int dani[N], paketi[N];
    long long p[N + 1];
    p[0] = 0;
int k=1;
int b=0;

    for (int i = 0; i < N; i++) {
        scanf("%d %d", &dani[i], &paketi[i]);
    }


    for (int j = 0; j < Q; j++) {
        long long  pitanje;
        scanf("%ld", &pitanje);
        a=0;
        k=1;
        while(a==0)
        {
            if(pitanje<dani[0])
            {
                p[j]=0;
                a=1;

            }
            else if(pitanje<dani[k])
            {
                p[j]=pitanje-(dani[k-1]-1);
                a=1;

            }
            else if(pitanje>dani[k])
            {
                p[j]=paketi[k]-(dani[k]-paketi[k-1]);

                a=1;

            }
            else
            {
                a=0;
            }
            k++;
        }

    }
for(int i=0;i<Q;i++)
{
    printf("%d\n", p[i]);
}


    return 0;
}